.code
	JMP init_atz_refs_insts
; =========== 
; Seta em ptr o endereco do programa que sera relocado.
; ===========
init_atz_refs_insts:
	MOV main
	STA ptr
; =========== 
; Atualiza os enderecos dos operandos das instrucoes do programa que sera 
;  relocado.
; ===========
atz_refs_insts:
	LDA tam_cod   ;while (cnt < tam_cod).
	SUB cnt
	JZ init_mov_prog

	LDI ptr       ;utiliza RDR para atualizar enderecos dos operandos.
	ADD RDR
	STI ptr

	MOV 1         ;aponta para a proxima instrucao.
	ADD ptr
	STA ptr

	MOV 1         ;cnt++.
	ADD cnt
	STA cnt
	
	JMP atz_refs_insts
; =========== 
; Salva na pilha do programa os novos enderecos dos registradores de 
;  segmento: SP, SS, DS e CS.
; ===========
init_mov_prog:
	MOV $SP	 ;salva na pilha o novo endereço de SP.
	ADD RDR
	SOP push

	MOV $SS	 ;salva na pilha o novo endereço de SS.
	ADD RDR
	SOP push

	MOV $DS	 ;salva na pilha o novo endereço de DS.
	ADD RDR
	SOP push

	MOV main   
	STA ptr         
	ADD RDR    
	STA ptr_n     ;ptr_n contem o novo endereco de CS.
	SOP push      ;salva na pilha o novo endereco de CS.

	MOV 0         ;reseta contador.
	STA cnt
; =========== 
; Copia programa para novo endereço de memoria (relocacao).
; ===========
mov_prog:
	LDA tam_prg   ;while (cnt < tam_prg).
	SUB cnt
	JZ init_prog

	LDI ptr       ;carrega instrucao no endereco antigo.
	STI ptr_n     ;grava instrucao no novo endereco (relocacao).

	MOV 1         ;aponta para a proxima instrucao do programa.
	ADD ptr
	STA ptr

	MOV 1         ;aponta para proximo endereco para copia da 
	ADD ptr_n     ; proxima instrucao do programa.
	STA ptr_n

	MOV 1         ;cnt++.
	ADD cnt
	STA cnt

	JMP mov_prog
; =========== 
;  Configura os registradores de segmento para apontarem para o programa
;   relocado. 
; ===========
init_prog:
	SOP pop
	STA ptr_n
	MOV -$CS      ;remove elemento da pilha e atualiza CS.

	SOP pop
	MOV -$DS      ;remove elemento da pilha e atualiza DS.

	SOP pop
	MOV -$SS      ;remove elemento da pilha e atualiza SS.

	SOP pop
	MOV -$SP      ;remove elemento da pilha e atualiza SP.

	MOV $CS       ;Seta no endereco de memoria 0x0 a instrucao de 
	ADD jmp_opc   ; salto para o programa relocado.
	STA @0x0
	JMP @0x0
; =========== 
; Programa que sera relocado em 200 enderecos: soma = v1 + v2.
; ===========
main:
	LDA v1
	ADD v2
	STA soma

end:
	INT exit

.data
	;syscall exit
	exit:  DD 25
	v1:      DD 10
	v2:      DD 20
	soma:    DD 0
; =========== 
; Fim do Programa
; ===========
	tam_prg: DD 8       ;tamanho do programa (4 inst + 4 dados).
	tam_cod: DD 4       ;tamanho do segmento de codigo.
	cnt:     DD 0
	push:    DD 0
	pop:     DD 1
	ptr:     DD 0       ;ponteiro utilizado o programa.
	ptr_n:   DD 0       ;ponteiro para mover o programa.
	RDR:     DD 200     ;atua como Registador de Relocação.
	jmp_opc: DD 0x8000  ;opcode da instrucao JMP.

.stack 10
